=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  Timo Aaltonen <tjaalton@debian.org>,
  Andreas Beckmann <anbe@debian.org>,
 Build-Depends: debhelper-compat (= 13),
+ g++-14,
  cmake,
  libz-dev,
 # keep the clang/llvm version in sync
@@ -17,7 +18,7 @@
 # prevent accidental backports after the 64-bit time_t transition
  dpkg-dev (>= 1.22.5),
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/intel/opencl-clang
 Vcs-Browser: https://salsa.debian.org/opencl-team/opencl-clang
 Vcs-Git: https://salsa.debian.org/opencl-team/opencl-clang.git -b llvm17/main
